// Vars
$font-family: 'Arial', sans-serif;
$color-theme-dark: #222222;
$color-theme-light: #dddddd;
$color-accent-1: #0066ff;
$color-accent-2: #66ff00;
$color-accent-3: #ff0066;

* {
  box-sizing: border-box;
  padding: 0;
  margin: 0;
  border: 0;
  font-family: $font-family;
}

html,
body {
  width: 100%;
  height: 100%;
}

body {
  position: relative;
  background-color: $color-theme-dark;
}

.radio-group {
  margin-top: 30px;
  margin-left: 30px;

  label {
    margin-right: 15px;
    color: $color-theme-light;
    cursor: pointer;

    input {
      margin-right: 5px;
    }
  }
}

.container {
  position: absolute;
  top: 50%;
  left: 50%;
  width: 200px;
  height: 200px;
  transform: translate(-50%, -50%);
  perspective: 600px;
}

.box {
  position: relative;
  width: 100%;
  height: 100%;
  transform: translateZ(-100px);
  transform-style: preserve-3d;
  transition: transform 2s;

  &.spin {
    animation: spin 6s ease-in-out infinite alternate;
  }

  &.front {
    transform: translateZ(-100px) rotateY(0);
  }

  &.back {
    transform: translateZ(-100px) rotateY(-180deg);
  }

  &.top {
    transform: translateZ(-100px) rotateX(-90deg);
  }

  &.bottom {
    transform: translateZ(-100px) rotateX(90deg);
  }

  &.left {
    transform: translateZ(-100px) rotateY(90deg);
  }

  &.right {
    transform: translateZ(-100px) rotateY(-90deg);
  }

  div {
    position: absolute;
    width: 100%;
    height: 100%;
    line-height: 200px;
    text-align: center;

    &.front {
      background-color: $color-accent-1;
      transform: rotateY(0) translateZ(100px);
    }

    &.back {
      background-color: $color-accent-1;
      transform: rotateY(180deg) translateZ(100px);
    }

    &.top {
      background-color: $color-accent-2;
      transform: rotateX(90deg) translateZ(100px);
    }

    &.bottom {
      background-color: $color-accent-2;
      transform: rotateX(-90deg) translateZ(100px);
    }

    &.left {
      background-color: $color-accent-3;
      transform: rotateY(-90deg) translateZ(100px);
    }

    &.right {
      background-color: $color-accent-3;
      transform: rotateY(90deg) translateZ(100px);
    }
  }
}

@keyframes spin {
  from {
    transform: translateZ(-100px) rotateX(0) rotateY(0);
  }

  to {
    transform: translateZ(-100px) rotateX(360deg) rotateY(360deg);
  }
}
